package jalview.gui;

import jalview.jbgui.*;
import jalview.datamodel.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.event.*;

public class RedundancyPanel extends GSliderPanel
{
  AlignmentPanel ap;

  SequenceI[] oldAlignment;


  public RedundancyPanel(AlignmentPanel ap)
  {
    this.ap = ap;

    label.setText("Enter the redundancy threshold");

    slider.addChangeListener(new ChangeListener()
    {
      public void stateChanged(ChangeEvent evt)
      {
        valueField.setText( slider.getValue()+"" );
      }
    });

    slider.setMinimum(0);
    slider.setMaximum(100);
    slider.setValue(100 );

  }

  public void applyButton_actionPerformed(ActionEvent e)
  {
       float threshold = slider.getValue();
       Vector del;

       oldAlignment = new SequenceI[ap.av.alignment.getHeight()];
        for (int i = 0; i < ap.av.alignment.getHeight(); i++)
        {
           oldAlignment[i] = new Sequence(ap.av.alignment.getSequenceAt(i).getName(),
                                ap.av.alignment.getSequenceAt(i).
                                getSequence());
        }

        undoButton.setEnabled(true);

       if (ap.av.sel != null && ap.av.sel.size() > 1)
       {

         del = ap.av.alignment.removeRedundancy(threshold, ap.av.sel.asVector());
         for (int i = 0; i < del.size(); i++)
           if (ap.av.sel.contains( (SequenceI) del.elementAt(i)))
             ap.av.sel.removeElement( (SequenceI) del.elementAt(i));

         }
         else
         {
           Vector s = new Vector();
           int i=0;
           while(i < ap.av.alignment.getHeight())
           {
             s.addElement( ap.av.alignment.getSequenceAt(i) );
             i++;
           }
            del = ap.av.alignment.removeRedundancy(threshold,s);
           for (int j=0; j < del.size(); j++)
           {
               if (ap.av.sel.contains((SequenceI)del.elementAt(j)))
               ap.av.sel.removeElement((SequenceI)del.elementAt(j));

           }
         }

         ap.RefreshPanels();

  }

  public void undoButton_actionPerformed(ActionEvent e)
  {
      undoButton.setEnabled(false);
      ap.av.setAlignment( new Alignment(oldAlignment) );
      oldAlignment = null;
      ap.RefreshPanels();
  }


  public void valueField_actionPerformed(ActionEvent e)
  {
    try{
      int i = Integer.parseInt(valueField.getText());
      slider.setValue(i);
    }
    catch(Exception ex)
    {
      valueField.setText( slider.getValue()+"" );
    }
  }
}
